 list       F=inhx8m, P=16F1937, R=hex, N=0
#include  P16F1937.inc; PIC definitions
 __config _config1,_FCMEN_OFF  & _IESO_ON & _CLKOUTEN_OFF & _BOREN_OFF  & _CPD_OFF & _CP_OFF & _MCLRE_ON  & _PWRTE_OFF & _WDTE_OFF & _FOSC_INTOSC
 __config _config2,_LVP_ON  & _BORV_27 & _STVREN_OFF & _PLLEN_OFF & _VCAPEN_OFF & _WRT_OFF
 Errorlevel -302      ; switches off Message [302]: Register in operand not in bank 0.
; Definitions -------------------------------------------------------------

#define LED_RED portc,2
#define LED_GREEN portc,3

#define Display_6 porte,2
#define Display_5 portb,0
#define Display_4 porte,1

#define Display_3 portb,2
#define Display_2 portb,1
#define Display_1 portb,3

#define Display_A portd,4
#define Display_B portd,7
#define Display_C portd,6
#define Display_D portd,5

#define TC_SO porta,7
#define TC_CS portc,0
#define TC_SCK porta,6

#define FanOutput porte,0
#define FanRPMFeedback porta,4

#define Fan_Wires_4 Flags,0
#define NegativeFlag Flags,1
#define Fan_RPM_Confirmation Flags,2
#define FirstDerivativeCheck Flags,3
#define HeaterPotitivePulse Flags,4
#define IntegralTimeDivider Flags,5

#define Button1 PORTB,4
#define Button2 PORTB,5 

#define HeaterGate PORTD,1



; RAM preserved -----------------------------------------------------------
	cblock 0x20
		WaitCounter,WaitCounter2
		Flags
		PassArg0,PassArg1,PassArg2,PassArg3,PassArg4,PassArg5,PassArg6,PassArg7,PassArg8,PassArg9,PassArg10,PassArg11,PassArg12,PassArg13
		Gain_Scale_Value,Gain_Scale_Scale,Gain_Scale_Max
		Thermo_H,Thermo_L
		Pot0_Value,Pot1_Value
		Temperature_SP
		FanSetSpeed
		TC_Cycle_Counter,RPM_Cycle_Counter,RPM_Set_Cycle
		Digit1_Number,Digit2_Number,Digit3_Number,Digit4_Number,Digit5_Number,Digit6_Number
		Gain_PID,Gain_P
		Gain_I,Time_I
		Gain_D,Time_D,Gain_D_Old
		Heater_Burst_Counter,Heater_Burst_Counter_2,Heater_Burst_Positive
		Current_Error
	endc
; Conastants --------------------------------------------------------------
TC_Read_Cycle_Interval	equ		d'100'
RPM_Cycle_Interval		equ		d'20'
RPM_Set_Interval		equ		d'20'
Fan_PWM_Min				equ		d'4'

HeaterBurstDelay		equ		d'25'	;Initial value
HeaterBurstPositive		equ		d'6'

RPM_Threshold			equ		d'20'

GAIN_P_Constant			equ		d'12'
GAIN_I_Constant			equ		d'10'
GAIN_D_Constant			equ		d'3'

TIME_I_Constant			equ		d'100'
TIME_D_Constant			equ		d'100'

GAIN_Divider			equ		d'40'

GAIN_P_Max				equ		d'45'
GAIN_I_Max				equ		d'45'
GAIN_D_Max				equ		d'45'

POut_Max				equ		d'46'
POut_Base				equ		d'50'

Switch_I				equ		0x01
Switch_D				equ		0x01


; Program Memory ----------------------------------------------------------
                org     0
                goto    Init

; Interrupt Service Routine -----------------------------------------------
                org     4               ; ISR beginning
				movlb 0x05		;	Set normal PWM DC
				BCF CCPTMRS0,4	;
				movlb 0x00
				bcf PIR1,TMR1GIF
				bcf LED_RED
				RETFIE

; -------------------------------------------------------------------------
; Microcontroller initialization
Init            
				include myInitilization.inc	;Include the PIC Initialization routine

;##########################################################################
; Main Program ------------------------------------------------------------

Start
				include initialization.inc ; Register and module initialization
				bsf  LED_GREEN





				
Mainloop
;////////////////////////////////////.///////////////
;// Thermocouple Reading Cycle
;///////////////////////////////////////////////////
				decf TC_Cycle_Counter,f			;Check If it time to read the thermocouple input
				btfss zero						;
				goto Cont1						;If not, just continue

				movlw TC_Read_Cycle_Interval	;OK it is time to read it
				movwf TC_Cycle_Counter			;
				call GetThermocoupleTemperature	;
				movf passarg5,w					;
				movwf Digit1_Number				;
				movf passarg4,w					;
				movwf Digit2_Number				;
				movf passarg3,w					;
				movwf Digit3_Number				;

;///////////////////////////////////////////////////
;// A/D read cycle
Cont1
				include a_d_reading.inc
Cont2
;///////////////////////////////////////////////////
				include output_burst_control.inc

Cont3

				movf Thermo_L,w				; SetPoint - Real Value
				subwf Temperature_SP,w		;
				movwf passarg1				;
				btfsc carry					; Was Real Value < Set Point?
				goto Cont3_A				; No,
				; Else... Result is negative, Check if result <-127
				btfsc passarg1,7			; If bit7 is set, then value is ok (-177<val<0)
				goto Cont3_B					; 
				movlw 0xFF					; Else load value 0xff (-127) to register
				movwf passarg1				;
				goto Cont3_B

Cont3_A			;Result if positive, Check if it is >127
				btfss passarg1,7			; If bit7 is clear, then value is ok (0<val<127)
				goto Cont3_B				; 
				movlw b'01111111'			; Else load value 0x7f (127) to register
				movwf passarg1				;
Cont3_B
				movf passarg1,w
				movwf Current_Error
				; At this point, we have the error in register Current_Error
				; The errror is a signed integer, -127 < Current_Error < 127

;////////////////////////////////////////////////////////////////////////
;// CALCULATE PROPORTIONAL VALUE
;////////////////////////////////////////////////////////////////////////
				movf Current_Error,w
				movwf Gain_Scale_Value
				movlw GAIN_P_Constant
				movwf Gain_Scale_Scale
				movlw GAIN_P_Max
				movwf Gain_Scale_Max
				call ScaleErrorToOutputGain

				movwf Gain_P			; Gain_P has the propotional gain signed


;////////////////////////////////////////////////////////////////////////
; CALCULATE INTEGRAL VALUE				
;////////////////////////////////////////////////////////////////////////

				btfsc HeaterPotitivePulse		; Do not accumulate integral if a positive
				goto Cont5						; pulse is active

				btfsc IntegralTimeDivider		;
				goto $+3						; Time division by 2
				bsf IntegralTimeDivider			;
				goto Cont5						;

				bcf  IntegralTimeDivider

				decf Time_I,f					;Decrease Integral time register
				btfss zero						;
				goto Cont5						;If not, just continue
				movlw TIME_I_Constant			;OK accumulate it
				movwf Time_I					;


				btfss LED_GREEN
				goto $+3
				bcf  LED_GREEN
				goto $+2
				bsf  LED_GREEN



				movf Current_Error,w
				movwf Gain_Scale_Value
				movlw GAIN_I_Constant
				movwf Gain_Scale_Scale
				movlw GAIN_I_Max
				movwf Gain_Scale_Max
				call ScaleErrorToOutputGain
				movwf PassArg3

				btfss Gain_I,7
				goto Cont4_IsPositive
Cont4_IsNegative
				movf PassArg3,w					;
				addwf Gain_I,f					; Add Pain_P to Gain_I
				btfsc Gain_I,7					; Is still negative?
				goto Cont4_Neg_CheckLim			; If yes, then continue
				;For some reason, the result is positive (changed). Either a positive number was added, or overflow occured
				btfss PassArg3,7				; If Gain_P was positive, then it was NOT an overflow
				goto Cont4_Pos_CheckLim			; and there is no problem
				;Otherwise, Gain_I must get the max number
				movlw GAIN_I_Max
				movwf Gain_I
				comf Gain_I,f
				incf Gain_I,f
				goto Cont5

Cont4_IsPositive
				movf PassArg3,w					;
				addwf Gain_I,f					; Add Gain_P to Gain_I
				btfss Gain_I,7					; Is still positive?
				goto Cont4_Pos_CheckLim			; If yes, then continue
				;For some reason, the result is negative. Either a negative number was added, or overflow occured
				btfsc PassArg3,7				; If Gain_P was negative, then it was NOT an overflow
				goto Cont4_Neg_CheckLim			; and there is no problem
				;Otherwise, Gain_I must get the max number
				movlw GAIN_I_Max
				movwf Gain_I
				goto Cont5

Cont4_Pos_CheckLim
				movlw GAIN_I_Max			; Check if it is above max value
				subwf Gain_I,w
				btfss carry
				goto Cont5
				movlw GAIN_I_Max			; If it is, then fix this value to max
				movwf Gain_I
				goto Cont5

Cont4_Neg_CheckLim
				comf Gain_I,w
				movwf passarg1
				incf passarg1,f

				movlw GAIN_I_Max			; Check if it is above max value
				subwf passarg1,w
				btfss carry
				goto Cont5
				movlw GAIN_I_Max			; If it is, then fix this value to max
				movwf Gain_I
				comf Gain_I,f
				incf Gain_I,f
				


;////////////////////////////////////////////////////////////////////////
; CALCULATE DERIVATIVE VALUE				
;////////////////////////////////////////////////////////////////////////
Cont5
				btfsc HeaterPotitivePulse		; Do not calculate derivative if a positive
				goto Cont55						; pulse is active

				decf Time_D,f					;Decrease Integral time register
				btfss zero						;
				goto Cont55						;If not, just continue
				movlw TIME_D_Constant			;OK accumulate it
				movwf Time_D					;

				movf Current_Error,w
				movwf Gain_Scale_Value
				movlw GAIN_D_Constant
				movwf Gain_Scale_Scale
				movlw GAIN_D_Max
				movwf Gain_Scale_Max
				call ScaleErrorToOutputGain
				movwf PassArg3					; value for Derivative

				btfss FirstDerivativeCheck
				goto $+5
				bcf FirstDerivativeCheck		; If thisis the first time that the derivatime term
				MOVF PassArg3,W					; is calculated, then the derivative has to be initialized,
				movwf Gain_D_Old				; To do this, i only update the old error with the current
				goto Cont55						; error and exit the routine

				;Otherwise calculate Derivative
				movf Gain_D_Old,w
				subwf PassArg3,w

				movwf Gain_D
				movf PassArg3,w
				movwf Gain_D_Old

;////////////////////////////////////////////////////////////////////////
; CALCULATE PID				
;////////////////////////////////////////////////////////////////////////
Cont55
				;Calculate the PID GAIN (Gain_P+Gain_I+Gain_D)
				movf Gain_P,w
				movwf Gain_PID

				movf Gain_I,w
				addwf Gain_PID,f 

				;movf Gain_D,w
				;addwf Gain_PID,f 


;				movf Gain_PID,w
;				movwf PassArg1
;				call Bin8ToDecimal
;				movf PassArg4,w
;				movwf Digit4_Number
;				movf PassArg5,w
;				movwf Digit5_Number
;				movf PassArg6,w
;				movwf Digit6_Number
;				call ShowDisplayDigits
			

Cont5_PID_SIze_Ok
				;Scale the total Gain (PID)
				btfsc Gain_PID,7
				goto Cont5_IsNegative

				movlw POut_Max
				subwf Gain_PID,w
				btfss carry
				goto Cont5_IsPositive
				movlw POut_Max
				movwf Gain_PID
				goto Cont5_IsPositive
Cont5_IsNegative
				comf Gain_PID,f			;
				incf Gain_PID,f			; Get 2's complement


				movlw POut_Max
				subwf Gain_PID,w
				btfss carry
				goto $+3
				movlw POut_Max
				movwf Gain_PID
				comf Gain_PID,f			;
				incf Gain_PID,f			; Get 2's complement
Cont5_IsPositive
				comf Gain_PID,f			;
				incf Gain_PID,f			; Get 2's complement
				movlw POut_Base
				addwf Gain_PID,w
 				movwf Heater_Burst_Counter_2
				movwf passarg1




				call ShowDisplayDigits
				goto MainLoop




;/////////////////////////////////////////////////////////////////////////////
; Scale a Gain value according to a Gain multiplier within specific range
; Arguments:
; Gain_Scale_Value - The value to be scaled [Signed]
; Gain_Scale_Scale - The gain multipler
; Gain_Scale_Max - The maximum limit
;
; On return, result in W  [Signed]
;/////////////////////////////////////////////////////////////////////////////
ScaleErrorToOutputGain
				bcf NegativeFlag
				movf Gain_Scale_Value,w
				movwf PassArg3

				btfss PassArg3,7			;
				goto $+4					;
				bsf  NegativeFlag			; Passarg3 = ABS |Current_Error|
				comf PassArg3,f				;
				incf PassArg3,f				;

				;Multiply By GAIN Constant
				movf PassArg3,w
				movwf PassArg1
				clrf passarg2
				movf Gain_Scale_Scale,w		; movlw GAIN_P_Constant
				movwf PassArg3
				clrf passarg4
				call Multiply16x16

				;And DIVIDE by GAIN_Divider
				movf passarg5,w
				movwf passarg3
				movf passarg6,w
				movwf passarg2
				movf passarg7,w
				movwf passarg1
				clrf passarg4
				clrf passarg5
				movlw GAIN_Divider
				movwf passarg6
				call Divide24By24			; Result in Passarg3

				movf Gain_Scale_Max,w		; movlw GAIN_P_Max			; Check if it is above max value
				subwf PassArg3,w
				btfss carry
				goto $+3
				movf Gain_Scale_Max,w		; movlw GAIN_P_Max			; If it is, then fix this value to max
				movwf passarg3

				btfss NegativeFlag			; Was a negative number?
				goto $+3					; No... Then go on 
				comf PassArg3,f
				incf PassArg3,f

				movf passarg3,w
				return



				include Display.inc
				include division24By24.inc
				include multiply16x16.inc
				include bcdToDecimal_3Digits.inc
				include 16binaryTo5BCD.inc
				include mSecDelayGenerator16MHz.inc
				include uSecDelays16MHz.inc

			

Fins	

                end             ; end of program
