				movlb 0x00				;Go to bank 0
				clrf PORTA
				clrf PORTB
				clrf PORTC
				clrf PORTD
				clrf PORTE
 
				clrf Gain_PID
				clrf Gain_P
				clrf Gain_I
				clrf Time_I

				clrf Gain_D
				clrf Time_D
				clrf Gain_D_Old

				movlw d'95'				;\
				movwf WaitCounter		;|
				movlw 0x21				;| Clear All RAM In Bank1
				movwf FSR1				;| Except first byte (WaitCounter)
				clrf INDF1				;| which i use as a counter right now
				incf fsr1,f				;| and does not need th be cleared
				decfsz WaitCounter,f	;|
				goto $-3				;/

				movlw GAIN_P_Constant
				movwf Gain_P
				movlw 0x01
				movwf TC_Cycle_Counter			
				movlw RPM_Cycle_Interval
				movwf RPM_Cycle_Counter			
				movlw RPM_Set_Interval
				movwf RPM_Set_Cycle
				movlw HeaterBurstDelay
				movwf Heater_Burst_Counter
				movlw HeaterBurstPositive
				movwf Heater_Burst_Positive
				movlw TIME_I_Constant
				movwf Time_I
				movlw TIME_D_Constant
				movwf Time_D
				bsf FirstDerivativeCheck

				clrf TMR1H
				clrf TMR1L

				bcf LED_GREEN
				bcf LED_RED
				bcf HeaterGate
				;TRIS setup
				movlb 0x01				;Go to bank 1
				movlw b'10111111'		;
				movwf TRISA				;Set the port pin types of the RA
				movlw b'11110000'		;
				movwf TRISB				;Set the port pin types of the RB
				movlw b'11110010'		;
				movwf TRISC				;Set the port pin types of the RC
				movlw b'00001101'		;
				movwf TRISD				;Set the port pin types of the RD
				movlw b'11111000'		;
				movwf TRISE				;Set the port pin types of the RE
				movlb 0x00				;Go to bank 0
				bcf HeaterGate
		
				;Setup TMR1		
				movlw b'00110101'		;
				movwf t1con				;

				;Setup TMR1 Gate for RPM measuring
				movlb 0x02
				bsf APFCON,T1GSEL		;T1G function is on RC4/SDI/SDA/T1G/SEG11
				movlb 0x00
				bsf T1GCON,TMR1GE		;Gate Enable
				bsf T1GCON,T1GPOL		;Timer1 gate is active-high (Timer1 counts when gate is high)
				bcf T1GCON,T1GTM		;Timer1 Gate Toggle mode
				bsf T1GCON,T1GSPM		;Timer1 gate Single-Pulse mode
				bcf T1GCON,T1GSS1		;\
				bcf T1GCON,T1GSS0		;-Timer0 overflow output
				bcf T1GCON,T1GGO		;

				;Setup PWM for FAN
				movlw 0xc0				;
				movwf PR2				; Period
				movlw b'00000100'		;
				movwf t2con				; TMR2 SETUP
				movlb 0x06				;
				movlw b'00001100'		;
				movwf CCP3CON			; CCP3 PWM mode
				movlw 0x9F				; 
				movwf CCPR3L			; Initial DC
				movlb 0x08				;\
				movlw 0x00				;| Setup also TMR4 for full Duty Cycle
				movwf PR4				;| When i want full duty cycle (pulse stretch method)
				movlw b'00000100'		;| i will use PR4 otherwise i use TMR2 (PR2)
				movwf t4con				;/

				;Setup A/D
				movlb 0x01
				movlw b'00000001'		;Enable A/D module
				movwf adcon0			;
				movlw b'00010000'		;Setup justification, module clock and reference voltage
				movwf adcon1			;
				movlb 0x03				;
				bsf ansela,0			; RA0 = Analog input
				bsf ansela,1			; RA1 = Analog input
				movlb 0x00				;
					
				;Setup Interrupt	
				clrf intcon				;
				bsf intcon,GIE			;
				bsf intcon,peie			;
				movlb 0x01				;
				clrf pie1				;
				clrf pie2				;
				clrf pie3				;
				bsf PIE1,TMR1GIE		;
				movlb 0x00				;
				bcf PIR1,TMR1GIF		;

				movlb 0x05				;	Set normal PWM DC
				BCF CCPTMRS0,4			;
				movlb 0x00				;

				;Setup Weak PULL-UP resistors for buttons
				movlb 0x04					;
				bsf WPUB,WPUB4				;
				bsf WPUB,WPUB5				;
				movlb 0x01					;
				bcf OPTION_REG,NOT_WPUEN	;
				movlb 0x00					;


				call wait250msec
				call wait250msec
				call wait250msec
				call wait250msec
				call wait250msec

				movlb 0x01					;
				movlw b'00000011'			;Start A/D for input RA0
				movwf adcon0				;
				movlb 0x00					;


				bcf HeaterGate

;///////////////////////////////////////////////////
;// Check Fan Type
;// Routine to see if a 3 or 4 wire fan is connected
;// The controller turns off PWM pulses
;// If a the tacho wire sends a negative pulse within 50mSec, then the fan is 4 wire
CheckFanType
				movlb 0x06
				movlw b'00000000'
				movwf CCP3CON			;Turn Off PWM Module
				movlb 0x00

				bcf FanOutput	;	PWM Output=0
				movlw d'50'
				movwf passarg1

				bcf Fan_Wires_4
				btfsc FanRPMFeedback
				goto $+3
				bsf  Fan_Wires_4
				goto $+4
				call wait1msec
				decfsz passarg1,f
				goto $-7

				movlb 0x06
				movlw b'00001100'
				movwf CCP3CON			;Turn On PWM Mopdule
				movlb 0x00
;///////////////////////////////////////////////////